import abc

class BasePlugin(abc.ABC):

    def onCreate(self, manifest_format, config):
        assert (hasattr(self, manifest_format))
        self.process = getattr(self, manifest_format)
        self.config = config

    # Plugins MUST reimplement at least this method to be valid
    # TODO: the right thing is to find a way to have Plugin class
    #  reimplement at least one amongst the 4 possible entrypoint.
    # Their name should be taken from the 4 supported formats
    #  that are now defined in pipeline.py
    @abc.abstractmethod
    def mpd(self, manifest):
        pass
