from manifest_edit import BasePlugin
from manifest_edit import ManifestIterator
import libfmp4


class Plugin(BasePlugin):
    '''
    supplemental_property plugin.

    The purpose of this plugin is to add a supplemental property with the
    configured schemeIdUri and Value as a SupplementalProperty, in the
    position specified in the configuration file.
    '''

    def addSupplementalProperty(self, manifest):

        manifest_iterator = ManifestIterator(self.config)

        for suppl_property_config, element in manifest_iterator(manifest,
                                             ['supplementalPropertyName', 'supplementalPropertyValue']):
            suppl_property = libfmp4.mpd.descriptor(
                suppl_property_config['supplementalPropertyName'],
                suppl_property_config['supplementalPropertyValue']
            )
            element.supplemental_properties.append(suppl_property)

    def mpd(self, manifest):
        self.addSupplementalProperty(manifest)
